=== tests/filesystem/CMakeLists.txt ===
# Copyright (c) Glyn Matthews 2020.
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

include(${PROJECT_SOURCE_DIR}/cmake/skyr-url-functions.cmake)

foreach (file_name filesystem_path_tests.cpp)
    skyr_create_test(${file_name} ${PROJECT_BINARY_DIR}/tests/filesystem test_name)
    target_link_libraries(${test_name} PRIVATE skyr-filesystem)
endforeach()
